#include	<Wt/WApplication>
#include	<Wt/WLabel>
#include	<Wt/WPopupMenu>
#include	<Wt/WContainerWidget>
#include	<Wt/WEnvironment>
#include	<Wt/WLineEdit>
#include	<Wt/WLogger>
#include	<Wt/WPushButton>
#include	<Wt/WServer>

using namespace std;

namespace
{
	class TestWidgetSet : public Wt::WApplication
	{
		Wt::WLineEdit* myEdit;
	public:
		TestWidgetSet( const Wt::WEnvironment& env )
			: Wt::WApplication( env )
		{
			Wt::WContainerWidget* top;
			bindWidget( top = new Wt::WContainerWidget(), *env.getParameter( "div" ) );
			myEdit = new Wt::WLineEdit;
			log( "info" ) << "environment().supportsCookies(): " << environment().supportsCookies();
			std::string cookie;
			try
			{
				cookie = environment().getCookie( "TestWidgetSet" );
			}
			catch( std::runtime_error& e )
			{
				log( "info" ) << "getCookie(): " << e.what();
			}
			myEdit->setText( cookie );

			Wt::WPushButton* button = new Wt::WPushButton( "write cookie" );
			button->clicked().connect( SLOT( this, TestWidgetSet::WriteCookie ) );
			
			top->addWidget( myEdit );
			top->addWidget( button );
		}
		void WriteCookie()
		{
			setCookie( "TestWidgetSet", myEdit->text().narrow(), 100000 );
		}
	};
	Wt::WApplication* createWidgetSet(const Wt::WEnvironment& env)
	{
	  return new TestWidgetSet( env );
	}

	void Run(int argc, char **argv)
	{
		Wt::WServer server( argv[0] );
		server.setServerConfiguration( argc, argv, WTHTTP_CONFIGURATION );
		server.addEntryPoint( Wt::WidgetSet, createWidgetSet, "/test_cookies.wtjs" );
		if( server.start() ) 
		{
			Wt::WServer::waitForShutdown();
			server.stop();
		}
	}
}
